// BongoConstraintParameterKeyframe.h: interface for the CBongoConstraintParameterKeyframe class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONGOCONSTRAINTPARAMETERKEYFRAME_H__928CE23F_17D6_4187_906D_977E01A83464__INCLUDED_)
#define AFX_BONGOCONSTRAINTPARAMETERKEYFRAME_H__928CE23F_17D6_4187_906D_977E01A83464__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BongoKeyframe.h"


typedef enum BONGO_CONSTRAINT_TYPE
{
    unknown_constraint		= 0,
	object_to_path			= 1,
	object_look_along_path	= 2,
	object_to_pivot			= 3,
	object_look_at			= 4,
	camera_to_path			= 5,
	camera_to_pivot			= 6,
	camera_look_along_path	= 7,
	target_to_path			= 8,
	target_to_pivot			= 9,
};


class BO_SDK_API_EXP CBongoConstraintParameterKeyframe  : public CBongoKeyframe
{
public:
	CBongoConstraintParameterKeyframe(BONGO_KEYFRAME_TYPE type);
	virtual ~CBongoConstraintParameterKeyframe();

	static CBongoConstraintParameterKeyframe* Cast(CBongoKeyframe*);

public:
	BONGO_CONSTRAINT_TYPE	ConstraintType() const;
	bool					SetConstraintType( BONGO_CONSTRAINT_TYPE type );

	double					Parameter() const;
	bool					SetParameter( double d );

	GUID					TargetObjectUuid() const;
	bool					SetTargetObjectUuid( GUID uuidTarget );

	double					Length();
	bool					SetLength(double d);

protected:
	double					m_dLength;	
	double					m_dParameter;
	GUID					m_uuidTarget;
	BONGO_CONSTRAINT_TYPE	m_Type;

};

#endif // !defined(AFX_BONGOCONSTRAINTPARAMETERKEYFRAME_H__928CE23F_17D6_4187_906D_977E01A83464__INCLUDED_)
