// BongoKeyframe.h: interface for the CBongoKeyframe class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONGOKEYFRAME_H__E6E1F08D_588F_43B8_B575_DC4E3927C2A6__INCLUDED_)
#define AFX_BONGOKEYFRAME_H__E6E1F08D_588F_43B8_B575_DC4E3927C2A6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


typedef enum BONGO_KEYFRAME_TYPE
{
	unknown_keyframe_type,
	object_keyframe,
	object_constraint_keyframe,
	view_keyframe,
	view_constraint_keyframe,
};


// object transformation parameter
DEFINE_GUID(BONGO_MOTION_KEYFRAME,			0x5b79c5d2, 0xaafe, 0x4ef6, 0x92, 0xc7, 0x21, 0xcd, 0x8d, 0x42, 0x3c, 0xd9);
DEFINE_GUID(BONGO_ROTATION_KEYFRAME,		0x40265210, 0x8a8, 0x41c5, 0xbb, 0xf1, 0x98, 0x7f, 0xce, 0xe1, 0x8f, 0x7);
DEFINE_GUID(BONGO_SCALING_KEYFRAME,			0xdb0f49f9, 0xee0a, 0x4dd0, 0x93, 0xee, 0x61, 0x6e, 0x77, 0xad, 0x9d, 0x3e);
// work arounds to delete whole-, general- or lightkeyframe
DEFINE_GUID(BONGO_GENERAL_KEYFRAME,			0x4a3e5dab, 0x7af1, 0x4326, 0x8a, 0x17, 0x19, 0xfe, 0xbd, 0x80, 0x40, 0x46);	
DEFINE_GUID(BONGO_LIGHT_KEYFRAME,			0xf12ed3fd, 0xd055, 0x4d6c, 0x98, 0x3, 0x92, 0x44, 0x5, 0xc8, 0x44, 0x6c);	
DEFINE_GUID(BONGO_WHOLE_KEYFRAME,			0x426efc65, 0x7f26, 0x420b, 0xbc, 0x8f, 0xd2, 0x9b, 0x74, 0x82, 0x5e, 0xd3);	

// light paramter
DEFINE_GUID(BONGO_LIGHT_COLOR,				0xb752ce0b, 0xc219, 0x4bdd, 0xb1, 0x34, 0x26, 0x42, 0x5e, 0x1c, 0x43, 0x31);
DEFINE_GUID(BONGO_LIGHT_SHADOW_INTENSITY,	0xb6f7d208, 0x1fcd, 0x4822, 0xaa, 0x29, 0x2d, 0xe5, 0x67, 0xdf, 0x21, 0x6e);
//DEFINE_GUID(BONGO_LIGHT_INTENSITY,			0xb3c0f2bb, 0x385f, 0x4426, 0xac, 0x61, 0x35, 0xd8, 0xcf, 0x4e, 0xea, 0xec);
DEFINE_GUID(BONGO_LIGHT_HOT_SPOT,			0x26a511b1, 0x3365, 0x49de, 0xa2, 0x1c, 0x7d, 0xb, 0xb5, 0x85, 0x3f, 0x7f);
DEFINE_GUID(BONGO_LIGHT_ON	,				0x5615eec9, 0xe077, 0x4431, 0x94, 0x35, 0xe2, 0xca, 0xef, 0xc9, 0x18, 0xf8);

// general parameter
DEFINE_GUID(BONGO_GENERAL_GLOSS_COLOR,		0xe162ca0d, 0x910, 0x4f87, 0xae, 0xde, 0x3, 0x88, 0x1e, 0x81, 0x74, 0x83);
DEFINE_GUID(BONGO_GENERAL_OBJECT_COLOR,		0x3ce7e4d6, 0x4a71, 0x4bf4, 0x8a, 0xb2, 0xff, 0xf2, 0xa0, 0x4d, 0x67, 0xde);
DEFINE_GUID(BONGO_GENERAL_MATERIAL_COLOR,	0x15245f39, 0x23f, 0x43e9, 0x86, 0x25, 0xb7, 0xdc, 0x8d, 0x49, 0x40, 0xe5);	
DEFINE_GUID(BONGO_GENERAL_GLOSS,			0x1a46bad3, 0xe15d, 0x4025, 0xa8, 0x79, 0xed, 0x88, 0xd2, 0x76, 0xa3, 0x9e);	
DEFINE_GUID(BONGO_GENERAL_TRANSPARENCY,		0x47386abb, 0xc19e, 0x4b2c, 0xb6, 0xb0, 0xd4, 0x6, 0x67, 0xdb, 0x8, 0xb5);	
DEFINE_GUID(BONGO_GENERAL_VISIBILITY,		0x16784e89, 0x75c2, 0x4a91, 0xa1, 0x5c, 0x31, 0xdd, 0x17, 0xb9, 0x5d, 0xf3);	

// views parameters
DEFINE_GUID(BONGO_VIEW_KEYFRAME,			0x4847b3f1, 0xec7c, 0x4284, 0x9a, 0x2a, 0xb0, 0x3b, 0x65, 0x98, 0xaf, 0xe);


class BO_SDK_API_EXP CBongoKeyframe  
{
public:
	CBongoKeyframe();
	virtual ~CBongoKeyframe();

public:

	BONGO_KEYFRAME_TYPE	Type() const;
	bool	SetType( BONGO_KEYFRAME_TYPE type );

	int		Smoothness() const;
	bool	SetSmoothness(int i);

	int		Continuity() const;
	bool	SetContinuity(int i);

	int		Bias() const;
	bool	SetBias(int i);

	int		Acceleration() const;
	bool	SetAcceleration(int i);

	int		Weight() const;
	bool	SetWeight(int i);

	bool	EaseIn() const;
	bool	SetEaseIn(bool b);

	bool	EaseOut() const;
	bool	SetEaseOut(bool b);

	double	Position() const;
	bool	SetPosition(double d);

protected:
	// Viewkeyframes use this values for position tweening.
	int		m_iSmoothness;
	int		m_iContinuity;
	int		m_iBias;
	int		m_iAcceleration;
	int		m_iWeight;

	bool	m_bEaseIn;
	bool	m_bEaseOut;

	double	m_dPosition;

	BONGO_KEYFRAME_TYPE m_KeyframeType;
};

#endif // !defined(AFX_BONGOKEYFRAME_H__E6E1F08D_588F_43B8_B575_DC4E3927C2A6__INCLUDED_)
