// BongoKeyframePtr.h: interface for the CBongoKeyframePtr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONGOKEYFRAMEPTR_H__24478BD1_2F7D_423F_9E9F_8D13019CEF9F__INCLUDED_)
#define AFX_BONGOKEYFRAMEPTR_H__24478BD1_2F7D_423F_9E9F_8D13019CEF9F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BongoKeyframe.h"

class CBongoKeyframe;

//Reference counted keyframe smart pointer

class BO_SDK_API_EXP CBongoKeyframePtr  
{
protected:
    // a helper class that holds the pointer to the managed object
    // and its reference count
    class Holder 
	{
    public:
        Holder( CBongoKeyframe* ptr) : pKF(ptr), m_iCount(1) {};
        ~Holder() { delete pKF;};
        
        CBongoKeyframe* pKF;
        unsigned int m_iCount;
    };
    
    Holder* pHolder; 
            
public:
    // constructor of CBongoKeyframePtr  (p must not be NULL)
	CBongoKeyframePtr();
    CBongoKeyframePtr( CBongoKeyframe* p );

    // destructor of CBongoKeyframePtr 
    ~CBongoKeyframePtr();

    // copy and assignment of CBongoKeyframePtr 
	CBongoKeyframePtr( const CBongoKeyframePtr& );
	CBongoKeyframePtr& operator=( const CBongoKeyframePtr& );
	CBongoKeyframePtr& operator=( CBongoKeyframe* );
	operator CBongoKeyframe*();

    // access to the managed object
	CBongoKeyframe* Pointee() const;
    CBongoKeyframe* operator->();
    CBongoKeyframe& operator*();
	bool operator!();

}; 

#endif // !defined(AFX_BONGOKEYFRAMEPTR_H__24478BD1_2F7D_423F_9E9F_8D13019CEF9F__INCLUDED_)
