// BongoViewKeyframe.h: interface for the CBongoViewKeyframe class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BONGOVIEWKEYFRAME_H__1C728378_D64C_4CE9_9974_1FA4DF1BE40A__INCLUDED_)
#define AFX_BONGOVIEWKEYFRAME_H__1C728378_D64C_4CE9_9974_1FA4DF1BE40A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BongoKeyframe.h"


class BO_SDK_API_EXP CBongoViewKeyframe	: public CBongoKeyframe
{
public:
	CBongoViewKeyframe();
	virtual ~CBongoViewKeyframe();

public:
	ON_3dVector	Direction() const;
	void		SetDirection(ON_3dVector v);

	double		RotationAngle() const;
	void		SetRotationAngle(double dAngle);

	ON_3dPoint	Location() const;
	void		SetLocation(ON_3dPoint pt);

	double		LensLength() const;
	void		SetLensLength(double d);

	ON_3dPoint	CameraTarget() const;
	void		SetCameraTarget(ON_3dPoint pt);


	//////////////////////////////////////////////////////////////////////////
	// Tweening

	// Up Vector
	int		BiasAngle() const;
	void	SetBiasAngle(int Bias);

	int		ContinuityAngle() const;
	void	SetContinuityAngle(int Continuity);

	int		SmoothnessAngle() const;
	void	SetSmoothnessAngle(int Smoothness);

	bool	EaseInAngle() const;
	void	SetEaseInAngle(bool bFlag);
	
	bool	EaseOutAngle() const;
	void	SetEaseOutAngle(bool bFlag);



	// Lens Length
	int		BiasLensLength() const;
	void	SetBiasLensLength(int Bias);

	int		ContinuityLensLength() const;
	void	SetContinuityLensLength(int Continuity);

	int		SmoothnessLensLength() const;
	void	SetSmoothnessLensLength(int Smoothness);

	bool	EaseInLensLength() const;
	void	SetEaseInLensLength(bool bFlag);
	
	bool	EaseOutLensLength() const;
	void	SetEaseOutLensLength(bool bFlag);



protected:
	int				m_iBiasAngle;
	int				m_iContinuityAngle;
	int				m_iSmoothnessAngle;
	bool			m_bEaseInAngle;
	bool			m_bEaseOutAngle;

	int				m_iBiasLensLength;
	int				m_iContinuityLensLength;
	int				m_iSmoothnessLensLength;
	bool			m_bEaseInLensLength;
	bool			m_bEaseOutLensLength;

	ON_3dPoint		m_ptLocation;
	ON_3dPoint		m_ptTarget;
	ON_3dVector		m_vDirection;
	double			m_dLensLength;
	double			m_dAngle;
};

#endif // !defined(AFX_BONGOVIEWKEYFRAME_H__1C728378_D64C_4CE9_9974_1FA4DF1BE40A__INCLUDED_)
