// BBTAddObjectToTreeCmd.cpp: implementation of the CBBTAddObjectToTreeCmd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTAddObjectToTreeCmd.h"
#include "bbtmain.h"

extern CBBTMain bbt;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

static class CBBTAddObjectToTreeCmd theBBTAddObjectToTreeCmd;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTAddObjectToTreeCmd::CBBTAddObjectToTreeCmd()
{
	wcsncpy( m_wszLocalCommandName, ThePlugIn().LocalizedString(4), BBT_STRING_BUFFER);
}

CBBTAddObjectToTreeCmd::~CBBTAddObjectToTreeCmd()
{

}

UUID CBBTAddObjectToTreeCmd::CommandUUID()
{
	// {CAEEECC1-73B0-4286-8A5A-26278C7893B1}
	static const GUID uuidAddObjectToTreeCmd = 
	{ 0xcaeeecc1, 0x73b0, 0x4286, { 0x8a, 0x5a, 0x26, 0x27, 0x8c, 0x78, 0x93, 0xb1 } };

	return uuidAddObjectToTreeCmd;;
}
	
void CBBTAddObjectToTreeCmd::DoHelp()
{
	
}

const wchar_t* CBBTAddObjectToTreeCmd::EnglishCommandName()
{
	return L"BongoBonusAnimateObject"; 
}

const wchar_t* CBBTAddObjectToTreeCmd::LocalCommandName() const 
{ 
	return m_wszLocalCommandName;
}

CRhinoCommand::result CBBTAddObjectToTreeCmd::RunBongoCommand( const CRhinoCommandContext& context )
{
	bbt.WakeUp();

	CBongo bongo;

	WCHAR wsz_Prompt[BBT_STRING_BUFFER];
	wcsncpy(wsz_Prompt, bongo.String(8001),BBT_STRING_BUFFER);

	CRhinoGetObject go;
	go.AcceptNothing();
	go.EnablePreSelect(true);
	go.SetCommandPrompt(wsz_Prompt);
	go.GetObjects(1,0);
	if( go.Result() != CRhinoGet::object )
			return CRhinoCommand::cancel;	

	for(int i=0; i<go.ObjectCount(); i++)
	{
		CBongoObject BongoObject(go.Object(i).Object()->Attributes().m_uuid);

		if(BongoObject.IsValid() && !BongoObject.IsAnimated())
		{
			BongoObject.Animate();
		}
	}


	return CRhinoCommand::success;
}
