// BBTDeleteObjectKeyframeRangeCmd.cpp: implementation of the CBBTDeleteObjectKeyframeRangeCmd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTDeleteObjectKeyframeRangeCmd.h"
#include "bbtmain.h"

extern CBBTMain bbt;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


static class CBBTDeleteObjectKeyframeRangeCmd theBBTDeleteObjectKeyframeRangeCmd;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTDeleteObjectKeyframeRangeCmd::CBBTDeleteObjectKeyframeRangeCmd()
{
	wcsncpy( m_wszLocalCommandName, ThePlugIn().LocalizedString(3), BBT_STRING_BUFFER);
}

CBBTDeleteObjectKeyframeRangeCmd::~CBBTDeleteObjectKeyframeRangeCmd()
{
	
}

UUID CBBTDeleteObjectKeyframeRangeCmd::CommandUUID()
{
	// {DF1C65C6-A0AF-403d-865B-3DF7DF4D1326}
	static const GUID uuidCommand = 
	{ 0xdf1c65c6, 0xa0af, 0x403d, { 0x86, 0x5b, 0x3d, 0xf7, 0xdf, 0x4d, 0x13, 0x26 } };

	return uuidCommand;
}
	
void CBBTDeleteObjectKeyframeRangeCmd::DoHelp()
{
	
}

const wchar_t* CBBTDeleteObjectKeyframeRangeCmd::EnglishCommandName()
{
	return L"BongoBonusDeleteObjectKeyframeRange"; 
}

const wchar_t* CBBTDeleteObjectKeyframeRangeCmd::LocalCommandName() const 
{ 
	return m_wszLocalCommandName;
}

CRhinoCommand::result CBBTDeleteObjectKeyframeRangeCmd::RunBongoCommand( const CRhinoCommandContext& context )
{
	bbt.WakeUp();

	CBongo bongo;
	WCHAR wsz_Prompt[BBT_STRING_BUFFER];
	wcsncpy(wsz_Prompt, bongo.String(8001),BBT_STRING_BUFFER);

	CRhinoGetObject go;
	go.AcceptNothing();
	go.EnablePreSelect(true);
	go.SetCommandPrompt(wsz_Prompt);
	go.GetObjects(1,0);
	if( go.Result() != CRhinoGet::object )
			return CRhinoCommand::cancel;	

	int iFrom, iTo;
	if(!CommandLineInput(iFrom, iTo))
		return CRhinoCommand::cancel;
	
	DeleteKeyframes(&go, iFrom, iTo);

	CBongoDoc* pBongoDoc = 0;
	if(CBongoDoc::DocumentObject(pBongoDoc) && pBongoDoc)
	{
		pBongoDoc->RefreshTimeline();
		pBongoDoc->RefreshScene();
	}
	
	delete pBongoDoc;

	return CRhinoCommand::success;
}

bool CBBTDeleteObjectKeyframeRangeCmd::CommandLineInput(int& iFrom, int& iTo)
{
	if(!GetCommandLineInteger( 2150, iFrom,0,BONGO_MAX_TIMELINE_RANGE-1,0,true,true))
		return false;

	if(!GetCommandLineInteger( 2151, iTo,1,BONGO_MAX_TIMELINE_RANGE-1-iFrom,iFrom+1,true,true))
		return false;

	return true;
}

bool CBBTDeleteObjectKeyframeRangeCmd::DeleteKeyframes(CRhinoGetObject* pGO, int iFrom, int iTo)
{
	if(!pGO)
		return false;

	CBongoObject BongoObject;

	for(int i=0; i<pGO->ObjectCount(); i++)
	{
		BongoObject.SetUuid(pGO->Object(i).Object()->Attributes().m_uuid);
		
		if(BongoObject.IsValid() && BongoObject.IsAnimated() && BongoObject.FirstKeyframe())
		{
			for(int j=iFrom; j<=iTo; j++)
			{
				BongoObject.DeleteKeyframe((double)j,BONGO_WHOLE_KEYFRAME,false);
			}
		}
	}

	return true;
}	
