// BBTEmailNotificationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTEmailNotificationDlg.h"
#include "LBPRegistryWrapper.h"
#include "bbtmain.h"

extern CBBTMain bbt;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBBTEmailNotificationDlg dialog


CBBTEmailNotificationDlg::CBBTEmailNotificationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBBTEmailNotificationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBBTEmailNotificationDlg)
	//}}AFX_DATA_INIT

	m_dwSmtpPort = 25;
	m_dwEachXFrame = 1;
	m_dwSendFrameNotification = 0;
	m_dwSendFinishedAnimationNotification = 0;
	m_dwAttachFrame = 0;
	m_dwEnableEmailNotification = 0;
}


void CBBTEmailNotificationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBBTEmailNotificationDlg)
	DDX_Control(pDX, IDC_STATIC_EMAIL_DETAILS, m_staticGroupEmailDetails);
	DDX_Control(pDX, IDC_CHECK_ENABLE_EMAIL_NOTIFICATION, m_checkEnableEmailNotification);
	DDX_Control(pDX, IDC_STATIC_SUBJECT, m_staticSubject);
	DDX_Control(pDX, IDC_CHECK_ATTACH_SINGLE_FRAME, m_checkAttachSingleFrames);
	DDX_Control(pDX, IDC_STATIC_SMTP_PORT_NUMBER, m_staticSmtpPortNumber);
	DDX_Control(pDX, IDC_EDIT_SMTP_PORT_NUMBER, m_editSmtpPortNumber);
	DDX_Control(pDX, IDC_STATIC_SMTP_GATEWAY, m_staticSmtpGateway);
	DDX_Control(pDX, IDC_STATIC_SENDERS_ADDRESS, m_staticSenderAddress);
	DDX_Control(pDX, IDC_STATIC_RECEIVER_ADDRESS, m_staticReceiverAddress);
	DDX_Control(pDX, IDC_STATIC_GROUP_FRAMES, m_staticGroupFrames);
	DDX_Control(pDX, IDC_STATIC_FRAMES_TO_SENT, m_staticSendEachXFrame);
	DDX_Control(pDX, IDC_EDIT_SUBJECT, m_editSubject);
	DDX_Control(pDX, IDC_EDIT_SMTP_GATEWAY, m_editSmtpGateway);
	DDX_Control(pDX, IDC_EDIT_SENDERS_ADDRESS, m_editSenderAddress);
	DDX_Control(pDX, IDC_EDIT_RECEIVER_ADDRESS, m_editReceiverAddress);
	DDX_Control(pDX, IDC_EDIT_FRAMES_TO_SEND, m_editSendEachXFrame);
	DDX_Control(pDX, IDC_CHECK_SEND_FRAME_NOTIFICATION, m_checkSendSingleFrameNotification);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBBTEmailNotificationDlg, CDialog)
	//{{AFX_MSG_MAP(CBBTEmailNotificationDlg)
	ON_BN_CLICKED(IDC_CHECK_SEND_FRAME_NOTIFICATION, OnCheckSendFrameNotification)
	ON_BN_CLICKED(IDC_CHECK_ENABLE_EMAIL_NOTIFICATION, OnCheckEnableEmailNotification)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBBTEmailNotificationDlg message handlers


BOOL CBBTEmailNotificationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SendMessage(WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)bbt.BongoIcon());
	
	ReadFromRegistry();

	Initialize();

	UpdateDisplay();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBBTEmailNotificationDlg::OnOK() 
{
	if(!GetValuesFromDisplay())
		return;

	if(m_dwEnableEmailNotification)
	{
		if(!ValidateInput())
			return;
	}

	WriteToRegistry();
	
	CDialog::OnOK();
}


bool CBBTEmailNotificationDlg::Initialize()
{
	m_editSmtpPortNumber.SetValue(m_dwSmtpPort);
	m_editSmtpPortNumber.SetBounds(0, 49151);
	m_editSmtpPortNumber.SetFixedSpinnerDelta(1);
	m_editSmtpPortNumber.SetSpinnerVisibility(true);

	m_editSendEachXFrame.SetValue(m_dwEachXFrame);
	m_editSendEachXFrame.SetBounds(1, BONGO_MAX_TIMELINE_RANGE);
	m_editSendEachXFrame.SetFixedSpinnerDelta(1);
	m_editSendEachXFrame.SetSpinnerVisibility(true);

	m_editReceiverAddress.SetWindowText(m_sReceiverAddress);
	
	m_editSenderAddress.SetWindowText(m_sSenderAddress);

	m_editSmtpGateway.SetWindowText(m_sSmptGateway);

	m_editSubject.SetWindowText(m_sSubject);

	m_checkAttachSingleFrames.SetCheck((int)m_dwAttachFrame);
	m_checkSendSingleFrameNotification.SetCheck((int)m_dwSendFrameNotification);
	m_checkEnableEmailNotification.SetCheck((int)m_dwEnableEmailNotification);

	return true;
}

bool CBBTEmailNotificationDlg::WriteToRegistry()
{
	CLBPRegistryWrapper reg;
	
	reg.SetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "SenderAddress", m_sSenderAddress);
	reg.SetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "ReceiverAddress", m_sReceiverAddress);
	reg.SetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "Subject", m_sSubject);
	reg.SetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "SmtpGateway", m_sSmptGateway);
	reg.SetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "SmtpPort", m_dwSmtpPort);
	reg.SetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "SendFrameNotification", m_dwSendFrameNotification);
	reg.SetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "SendEachXFrame", m_dwEachXFrame);
	reg.SetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "AttachRenderedFrame", m_dwAttachFrame);
	reg.SetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "EnableEmailNotification", m_dwEnableEmailNotification);

	return true;
}

bool CBBTEmailNotificationDlg::ReadFromRegistry()
{
	CLBPRegistryWrapper reg;
	
	reg.GetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "SenderAddress", m_sSenderAddress);
	reg.GetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "ReceiverAddress", m_sReceiverAddress);
	reg.GetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "Subject", m_sSubject);
	reg.GetStringValue(HKEY_CURRENT_USER, BBT_REGPATH, "SmtpGateway", m_sSmptGateway);
	reg.GetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "SmtpPort", m_dwSmtpPort, 25);
	reg.GetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "SendFrameNotification", m_dwSendFrameNotification,0);
	reg.GetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "SendEachXFrame", m_dwEachXFrame, 1);
	reg.GetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "AttachRenderedFrame", m_dwAttachFrame, 0);
	reg.GetDWORDValue(HKEY_CURRENT_USER, BBT_REGPATH, "EnableEmailNotification", m_dwEnableEmailNotification,0);

	return true;
}

bool CBBTEmailNotificationDlg::GetValuesFromDisplay()
{
	CString sValue;

	m_editReceiverAddress.GetWindowText(sValue);
	m_sReceiverAddress = sValue;

	m_editSenderAddress.GetWindowText(sValue);
	m_sSenderAddress = sValue;
	
	m_editSmtpGateway.GetWindowText(sValue);
	m_sSmptGateway = sValue;

	m_editSubject.GetWindowText(sValue);
	m_sSubject = sValue;
	
	m_dwAttachFrame = (DWORD)m_checkAttachSingleFrames.GetCheck();
	m_dwSendFrameNotification = (DWORD)m_checkSendSingleFrameNotification.GetCheck();
	m_dwEnableEmailNotification = (DWORD)m_checkEnableEmailNotification.GetCheck();

	if(!m_editSendEachXFrame.IsBlank())
	{
		m_dwEachXFrame = m_editSendEachXFrame.GetValue();
	}
	
	if(!m_editSmtpPortNumber.IsBlank())
	{
		m_dwSmtpPort = m_editSmtpPortNumber.GetValue();
	}

	return true;
}

bool  CBBTEmailNotificationDlg::ValidateInput(bool bSilent)
{
	if(!IsValidEmailAddress(m_sReceiverAddress))
	{
		if(!bSilent)
		{
			BBTMsgBox(ThePlugIn().LocalizedString(1012), MB_OK|MB_ICONINFORMATION);
		}

		return false;
	}


	if(m_sSenderAddress.IsEmpty() || !IsValidEmailAddress(m_sSenderAddress))
	{
		if(!bSilent)
		{
			BBTMsgBox(ThePlugIn().LocalizedString(1013), MB_OK|MB_ICONINFORMATION);
		}

		return false;
	}


	if(m_sSmptGateway.IsEmpty() || !IsValidDomainName(m_sSmptGateway))
	{
		if(!bSilent)
		{
			BBTMsgBox(ThePlugIn().LocalizedString(1014), MB_OK|MB_ICONINFORMATION);
		}

		return false;
	}

	return true;
}

void CBBTEmailNotificationDlg::UpdateDisplay()
{
	BOOL bEnable = m_checkEnableEmailNotification.GetCheck();
	
	m_checkSendSingleFrameNotification.EnableWindow(bEnable);

	m_staticGroupEmailDetails.EnableWindow(bEnable);
	m_staticReceiverAddress.EnableWindow(bEnable);
	m_staticSenderAddress.EnableWindow(bEnable);
	m_staticSmtpGateway.EnableWindow(bEnable);
	m_staticSmtpPortNumber.EnableWindow(bEnable);
	m_staticSubject.EnableWindow(bEnable);

	m_editReceiverAddress.EnableWindow(bEnable);
	m_editSenderAddress.EnableWindow(bEnable);
	m_editSmtpGateway.EnableWindow(bEnable);
	m_editSmtpPortNumber.EnableWindow(bEnable);
	m_editSubject.EnableWindow(bEnable);

	if(bEnable && !m_checkSendSingleFrameNotification.GetCheck())
	{
		bEnable = FALSE;
	}

	m_staticGroupFrames.EnableWindow(bEnable);
	m_staticSendEachXFrame.EnableWindow(bEnable);
	m_editSendEachXFrame.EnableWindow(bEnable);
	m_checkAttachSingleFrames.EnableWindow(bEnable);
}
void CBBTEmailNotificationDlg::OnCheckSendFrameNotification() 
{
	UpdateDisplay();	
}

void CBBTEmailNotificationDlg::OnCheckEnableEmailNotification() 
{
	UpdateDisplay();	
}


DWORD CBBTEmailNotificationDlg::IsEmailNotificationEnabled()
{
	return m_dwEnableEmailNotification;
}

const char* CBBTEmailNotificationDlg::SenderAddress()
{
	return m_sSenderAddress;
}

const char* CBBTEmailNotificationDlg::RecipientAddress()
{
	return m_sReceiverAddress;
}

const char* CBBTEmailNotificationDlg::Subject()
{
	return m_sSubject;
}

const char* CBBTEmailNotificationDlg::SmtpGateway()
{
	return m_sSmptGateway;
}

DWORD CBBTEmailNotificationDlg::SendFrameNotification()
{
	return m_dwSendFrameNotification;
}

DWORD CBBTEmailNotificationDlg::NotifyEachXFrame()
{
	return m_dwEachXFrame;
}

DWORD CBBTEmailNotificationDlg::AttachSingleFrame()
{
	return m_dwAttachFrame;
}

DWORD CBBTEmailNotificationDlg::SmtpPortNumber()
{
	return m_dwSmtpPort;
}

