#if !defined(AFX_BBTEMAILNOTIFICATIONDLG_H__720B9A94_D5D8_4B86_AD35_99E5CA45215A__INCLUDED_)
#define AFX_BBTEMAILNOTIFICATIONDLG_H__720B9A94_D5D8_4B86_AD35_99E5CA45215A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BBTEmailNotificationDlg.h : header file
//

#include "LBPIntegerNumberEdit.h"
#include "resource.h"

/////////////////////////////////////////////////////////////////////////////
// CBBTEmailNotificationDlg dialog

class CBBTEmailNotificationDlg : public CDialog
{
// Construction
public:
	CBBTEmailNotificationDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CBBTEmailNotificationDlg)
	enum { IDD = IDD_EMAIL_NOTIFICATION };
	CButton	m_staticGroupEmailDetails;
	CButton	m_checkEnableEmailNotification;
	CStatic	m_staticSubject;
	CButton	m_checkAttachSingleFrames;
	CStatic	m_staticSmtpPortNumber;
	CLBPIntegerNumberEdit	m_editSmtpPortNumber;
	CStatic	m_staticSmtpGateway;
	CStatic	m_staticSenderAddress;
	CStatic	m_staticReceiverAddress;
	CButton	m_staticGroupFrames;
	CStatic	m_staticSendEachXFrame;
	CEdit	m_editSubject;
	CEdit	m_editSmtpGateway;
	CEdit	m_editSenderAddress;
	CEdit	m_editReceiverAddress;
	CLBPIntegerNumberEdit	m_editSendEachXFrame;
	CButton	m_checkSendSingleFrameNotification;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBBTEmailNotificationDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CBBTEmailNotificationDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnCheckSendFrameNotification();
	afx_msg void OnCheckEnableEmailNotification();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	bool ValidateInput(bool bSilent = false);
	bool ReadFromRegistry();
	bool GetValuesFromDisplay();

protected:
	bool Initialize();
	bool WriteToRegistry();
	void UpdateDisplay();

public:
	const char* SenderAddress();
	const char* RecipientAddress();
	const char* Subject();
	const char* SmtpGateway();
	DWORD SendFrameNotification();
	DWORD NotifyEachXFrame();
	DWORD AttachSingleFrame();
	DWORD SmtpPortNumber();
	DWORD IsEmailNotificationEnabled();

private:
	CString m_sSenderAddress;
	CString m_sReceiverAddress;
	CString m_sSubject;
	CString m_sSmptGateway;
	DWORD m_dwSendFrameNotification;
	DWORD m_dwEachXFrame;
	DWORD m_dwSmtpPort;
	DWORD m_dwSendFinishedAnimationNotification;
	DWORD m_dwEnableEmailNotification;
	DWORD m_dwAttachFrame;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BBTEMAILNOTIFICATIONDLG_H__720B9A94_D5D8_4B86_AD35_99E5CA45215A__INCLUDED_)
