// BBTEventWatcher.h: interface for the CBBTEventWatcher class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTEVENTWATCHER_H__CBE2DE1F_A709_48A9_8ACE_D7C6AF7BBF40__INCLUDED_)
#define AFX_BBTEVENTWATCHER_H__CBE2DE1F_A709_48A9_8ACE_D7C6AF7BBF40__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBBTEmailNotifierMgr;
class CBBTRenderAnimationFileCollectionMgr;

void CALLBACK RenderFileCollectionTimer(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime ); 

class CBBTEventWatcher  : public CBongoEventWatcher
{
public:
	CBBTEventWatcher();
	virtual ~CBBTEventWatcher();

public:
	void EnableRenderAnimationFileCollectionEvents(bool bEnable = true);

protected:
	void OnBongoSettingsChanged();

	void OnBongoObjectAnimationChanged( UUID uuidObject );

	void OnBongoViewAnimationChanged( const WCHAR* wszName );

	void OnSliderPositionWillChange( double dOldPos, double dNewPos );
	void OnSliderPositionChanged( double dOldPos, double dNewPos );

	void OnRenderAnimationWillStart(int iCommandStyle);

	void OnAnimationFrameWritten( const WCHAR* wszFileName, int iFrameNumber, double dTimelinePosition );

	void OnRenderAnimationCanceled(const WCHAR* wszOutputFile);

	void OnEncodingWillStart( const WCHAR* wszFirstFileInSequence, const WCHAR* wszOutputFile,
								int iSpeedInFPS, int iStartFrame, int iStopFrame ); 

	void OnRenderAnimationFinished(const WCHAR* wszOutputFile);

	void OnAnimationModeChanged( BOOL bAnimationMode );
	void OnPreviewStarted();
	void OnPreviewStopped();
	void OnPreviewPaused();
	void OnTimelineTicksChanged();

	void OnContextMenuDisplay(HMENU hMenu,
		const CONTEXT_MENU_TYPE type,
		const CONTEXT_MENU_VARIANT* pVar,
		const int iCmdFirst,
		const int iCmdLast);

	void OnContextMenuItemInvoke(const CONTEXT_MENU_TYPE type,
		const CONTEXT_MENU_VARIANT* pVar,
		const int iCmdCode,
		const int iCmdFirst);


private:
	CBBTEmailNotifierMgr* m_pEmailNotifierMgr;
	CBBTRenderAnimationFileCollectionMgr* m_pRenderFileCollection;
	bool m_bEnableRenderAnimationFileCollectionEvents;
	bool m_bTimerEnabled;

};

#endif // !defined(AFX_BBTEVENTWATCHER_H__CBE2DE1F_A709_48A9_8ACE_D7C6AF7BBF40__INCLUDED_)
