// BBTGraphicalDisplayCmd.cpp: implementation of the CBBTGraphicalDisplayCmd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "bbtapp.h"
#include "BBTGraphicalDisplayCmd.h"
#include "BBTGraphicDisplayControlBar.h"
#include "bbtmain.h"

extern CBBTMain bbt;


//static class CBBTGraphicalDisplayCmd theBBTGraphicalDisplayCmd;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTGraphicalDisplayCmd::CBBTGraphicalDisplayCmd()
{
	wcsncpy( m_wszLocalCommandName, ThePlugIn().LocalizedString(13), BBT_STRING_BUFFER);
}

CBBTGraphicalDisplayCmd::~CBBTGraphicalDisplayCmd()
{

}

UUID CBBTGraphicalDisplayCmd::CommandUUID()
{
	// {5196EF87-519D-465c-A7AC-28266C28DA4F}
	static const GUID uuidGraphicalDisplayCmd = 
	{ 0x5196ef87, 0x519d, 0x465c, { 0xa7, 0xac, 0x28, 0x26, 0x6c, 0x28, 0xda, 0x4f } };

	return uuidGraphicalDisplayCmd;
}
	
void CBBTGraphicalDisplayCmd::DoHelp()
{
	
}

const wchar_t* CBBTGraphicalDisplayCmd::EnglishCommandName()
{
	return L"BongoBonusGraphicalDisplay"; 
}

const wchar_t* CBBTGraphicalDisplayCmd::LocalCommandName() const 
{ 
	return m_wszLocalCommandName;
}

CRhinoCommand::result CBBTGraphicalDisplayCmd::RunBongoCommand( const CRhinoCommandContext& context )
{
	USES_CONVERSION;

	bbt.WakeUp();

	CWnd* pMainWnd = RhinoApp().m_pMainWnd;
	if(!pMainWnd)	{return CRhinoCommand::failure;}
	
	CFrameWnd* pFrameWnd = (CFrameWnd*)pMainWnd;
	if(!pMainWnd)	{return CRhinoCommand::failure;}

	CBongo bo;
	
	if(bbt.GraphicDisplayControlBar())
	{
		AFX_MANAGE_STATE( ::RhinoApp().RhinoModuleState() );

		CWnd* pWndGraphicalDisplay = CWnd::FromHandle(bbt.GraphicDisplayControlBar().m_hWnd);
		if(!pWndGraphicalDisplay)	{return CRhinoCommand::failure;}

		if(!context.IsInteractive())
		{

			WCHAR wsz_Prompt[BBT_STRING_BUFFER];
			wcsncpy(wsz_Prompt,ThePlugIn().LocalizedString(2170),BBT_STRING_BUFFER);

			ON_wString wDefault;

			CRhinoGetOption go;
			go.AcceptNothing();
			go.SetCommandPrompt(wsz_Prompt);

			BOOL bVisible = pWndGraphicalDisplay->IsWindowVisible();
			int iIndex = bVisible;

			for(;;)
			{
				CRhinoGetOption go;
				go.AcceptNothing();
				go.SetCommandPrompt(wsz_Prompt);
				int iOption_index = go.AddCommandOptionList(
					CBBTCommandOptionName(2907),
                    iIndex,
                    CBBTCommandOptionValue(2904),
                    CBBTCommandOptionValue(2905),
                    CBBTCommandOptionValue(2906)
                    );

					go.GetOption();
					switch (go.Result())
					{
					case CRhinoGet::cancel:
						return CRhinoCommand::cancel; // user pressed ESCAPE
					
					case CRhinoGet::nothing:		// user pressed ENTER
							if(0 == iIndex)			{bVisible = TRUE;}
							else if(1 == iIndex)	{bVisible = FALSE;}
							else					{bVisible = !bVisible;}
							pFrameWnd->ShowControlBar( &bbt.GraphicDisplayControlBar(), bVisible, FALSE );
						return CRhinoCommand::success;

					case CRhinoGet::option:
						const CRhinoCommandOption* opt = go.Option();
						if ( opt->m_option_index == iOption_index)
						{	
							iIndex = opt->m_list_option_current;


							if(0 == iIndex)			{bVisible = TRUE;}
							else if(1 == iIndex)	{bVisible = FALSE;}
							else					{bVisible = !bVisible;}
								
								
							pFrameWnd->ShowControlBar( &bbt.GraphicDisplayControlBar(), bVisible, FALSE );
							break;
						}
					
					}
			}
		}
		else	
		{
			pFrameWnd->ShowControlBar( &bbt.GraphicDisplayControlBar(), true, false );
		}

		bbt.GraphicDisplayControlBar().RefreshDisplay();
	}

	return CRhinoCommand::success;
}

