// BBTObjectWrapper.h: interface for the CBBTObjectWrapper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTOBJECTWRAPPER_H__5CBDE9C0_839F_4AAC_858F_6937AC56FEE8__INCLUDED_)
#define AFX_BBTOBJECTWRAPPER_H__5CBDE9C0_839F_4AAC_858F_6937AC56FEE8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBBTObjectWrapper  
{
public:
	CBBTObjectWrapper();
	virtual ~CBBTObjectWrapper();

public:
	int KeyframeCount(CBongoObject* pObject);
	bool ValidateObjects(CRhinoGetObject* pGO, bool bIncludeKeyframesCheck = true);
	bool GetObjectKeyframes(CBongoObject* pObject, CArray<CBongoObjectKeyframe*, CBongoObjectKeyframe*>& aKFs);
	bool GetObjectKeyframePositions(CBongoObject* pObject, CArray<double, double>& aKFPos);
	bool DeleteAllKeyframes(CBongoObject* pObject);
	bool IsKeyframeAtPos(CBongoObject* pObject, double dPos);
	void CollectAnimatedObjects(CArray<const CRhinoObject*, const CRhinoObject*>& aObjects);
	int SelectedObjectCount(bool bNeedToBeAnimated = false, bool bNeedToHaveKeyframes = false);
};

#endif // !defined(AFX_BBTOBJECTWRAPPER_H__5CBDE9C0_839F_4AAC_858F_6937AC56FEE8__INCLUDED_)
