/////////////////////////////////////////////////////////////////////////////
// BBTPlugIn.h
//

#if !defined(AFX_BBTPLUGIN_H__68BB96E3_CF22_4EF7_B3E4_07E4B3B8D286__INCLUDED_)
#define AFX_BBTPLUGIN_H__68BB96E3_CF22_4EF7_B3E4_07E4B3B8D286__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CBBTPlugIn
// See BBTPlugIn.cpp for the implementation of this class.
//

#include "LBPString.h"

class CLBP_XMLStringTable;
class CBBTRhinoEventWatcher;

class CBBTPlugIn : public CRhinoUtilityPlugIn
{
public:
  CBBTPlugIn();
  ~CBBTPlugIn();

  ///////////////////////////////////////////////////////////////////////////
  // General plug-in overrides
  const wchar_t* PlugInName() const;
  const wchar_t* PlugInVersion() const;
  GUID PlugInID() const;

  BOOL OnLoadPlugIn();
  void OnUnloadPlugIn();

public:
  ON_wString m_sPlugInVersion;
  ON_String m_sProfileSection;

///////////////////////////////////////////////////
//
//	OWN STUFF
//
public:
	CLBPString& LocalizedString( DWORD dwID, bool bEnglishVersion = false );


protected:
	BOOL OnPlugInMenuCommand(WPARAM wParam);
	bool CreateStringTables();
	bool AddMenu();


private:
	CLBP_XMLStringTable*	m_pLocalizedStrings;
	CLBP_XMLStringTable*	m_pEnglishStrings;
	CBBTRhinoEventWatcher* m_pRhinoEventWatcher;

	bool m_bStringTablesCreated;
	bool m_bInitialized;

	HMENU m_hMenu;
};

CBBTPlugIn& ThePlugIn();

#endif // !defined(AFX_BBTPLUGIN_H__68BB96E3_CF22_4EF7_B3E4_07E4B3B8D286__INCLUDED_)


