// BBTSaveCameraCSVFileCmd.h: interface for the CBBTSaveCameraCSVFileCmd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTSAVECAMERACSVFILECMD_H__41D1F0ED_4609_4360_B0FC_849F42F7D010__INCLUDED_)
#define AFX_BBTSAVECAMERACSVFILECMD_H__41D1F0ED_4609_4360_B0FC_849F42F7D010__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBBTSaveCameraCSVFileCmd  : public CBongoCommand
{
public:
	CBBTSaveCameraCSVFileCmd();
	virtual ~CBBTSaveCameraCSVFileCmd();

public:
	UUID CommandUUID();

public:
	const wchar_t* EnglishCommandName();
	const wchar_t* LocalCommandName() const;
	CRhinoCommand::result RunBongoCommand( const CRhinoCommandContext& );
	virtual void DoHelp();

protected:
	bool WriteHeading(CRhinoViewport* pView, CString& sFile);
	bool WriteData(CBongoViewKeyframe* pKF, CString& sFile);
	bool WriteEnd(CRhinoViewport* pView, CString& sFile);
	double LensLengthToFOV(double dLensLength);
	bool BrowseForFile(CString& sFile);
	bool IsValidFilePath(const char* szFile);
	bool FitDelimterToLocaleId(CString& sData);
	
private:
	WCHAR m_wszLocalCommandName[BBT_STRING_BUFFER];
};

#endif // !defined(AFX_BBTSAVECAMERACSVFILECMD_H__41D1F0ED_4609_4360_B0FC_849F42F7D010__INCLUDED_)
