// BBTScaleObjectKeyframesCmd.h: interface for the CBBTScaleObjectKeyframesCmd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTSCALEOBJECTKEYFRAMESCMD_H__7474145E_E9A2_4929_BD48_8D82327B7040__INCLUDED_)
#define AFX_BBTSCALEOBJECTKEYFRAMESCMD_H__7474145E_E9A2_4929_BD48_8D82327B7040__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBBTScaleObjectKeyframesCmd  : public CBongoCommand
{
public:
	CBBTScaleObjectKeyframesCmd();
	virtual ~CBBTScaleObjectKeyframesCmd();

public:
	UUID CommandUUID();

public:
	const wchar_t* EnglishCommandName();
	const wchar_t* LocalCommandName() const;
	CRhinoCommand::result RunBongoCommand( const CRhinoCommandContext& );
	virtual void DoHelp();
	

protected:
	struct OBJECT_DATA
	{
		CBongoObject* pBongoObject;
		CArray<CBongoKeyframe*, CBongoKeyframe*> aKFs;
	};

	enum SCALING_DIRECTION
	{
		scale_right,
		scale_left,
		scale_left_and_right
	};

protected:
	int CreateObjectData(CRhinoGetObject* pObjectSelection);
	void FlushObjects();
	bool CommandLineInput(int& iOrigin, double& dScalingFactor, SCALING_DIRECTION& sd);
	bool GetScalingDirection(SCALING_DIRECTION& sd);
	bool ScaleKeyframes(int iOrigin, double dScalingFactor, SCALING_DIRECTION sd);
	bool SetKeyframes();

private:
	WCHAR m_wszLocalCommandName[BBT_STRING_BUFFER];
	CArray<OBJECT_DATA*, OBJECT_DATA*> m_aObjects;
};

#endif // !defined(AFX_BBTSCALEOBJECTKEYFRAMESCMD_H__7474145E_E9A2_4929_BD48_8D82327B7040__INCLUDED_)
