// BBTScaleViewKeyframesCmd.h: interface for the CBBTScaleViewKeyframesCmd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BBTSCALEVIEWKEYFRAMESCMD_H__0E187526_D340_4EA0_BD1B_21F65BE7530D__INCLUDED_)
#define AFX_BBTSCALEVIEWKEYFRAMESCMD_H__0E187526_D340_4EA0_BD1B_21F65BE7530D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CBBTScaleViewKeyframesCmd  : public CBongoCommand
{
public:
	CBBTScaleViewKeyframesCmd();
	virtual ~CBBTScaleViewKeyframesCmd();

public:
	UUID CommandUUID();

public:
	const wchar_t* EnglishCommandName();
	const wchar_t* LocalCommandName() const;
	CRhinoCommand::result RunBongoCommand( const CRhinoCommandContext& );
	
	virtual void DoHelp();

protected:
	enum SCALING_DIRECTION
	{
		scale_right,
		scale_left,
		scale_left_and_right
	};

protected:
	bool CommandLineInput(int& iOrigin, double& dScalingFactor, SCALING_DIRECTION& sd);
	bool GetScalingDirection(SCALING_DIRECTION& sd);
	bool ScaleKeyframes(CBongoView* pView,int iOrigin, double dScalingFactor, SCALING_DIRECTION sd,
		CArray<CBongoKeyframe*, CBongoKeyframe*>& aKFs);
	bool SetKeyframes(CBongoView* pView, CArray<CBongoKeyframe*, CBongoKeyframe*>& aKFs);
	bool ValidateView(CBongoView* pView);

private:
	WCHAR m_wszLocalCommandName[BBT_STRING_BUFFER];
};



#endif // !defined(AFX_BBTSCALEVIEWKEYFRAMESCMD_H__0E187526_D340_4EA0_BD1B_21F65BE7530D__INCLUDED_)
