// BBTTimelineExtension.cpp: implementation of the CBBTTimelineExtension class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BBTTimelineExtension.h"
#include "BBTObjectWrapper.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTTimelineExtension::CBBTTimelineExtension()
{
	m_pObjectSubMenu = new CMenu;
	m_pViewSubMenu = new CMenu;
}

CBBTTimelineExtension::~CBBTTimelineExtension()
{
	delete m_pObjectSubMenu;
	m_pObjectSubMenu = 0;

	delete m_pViewSubMenu;
	m_pViewSubMenu = 0;
}

bool CBBTTimelineExtension::OnContextMenuDisplay(HMENU hMenu, const int iFirstCmd, const int iLastCmd)
{
	CMenu* pMenu = CMenu::FromHandle(hMenu);
	if(!pMenu)	return false;

	// check if command range is enough to fit our menu
	if((iLastCmd-iFirstCmd+1) < 8)
		return false;

	pMenu->AppendMenu(MF_SEPARATOR);


	// timeline menu

	pMenu->AppendMenu(MF_ENABLED, iFirstCmd + 0, ThePlugIn().LocalizedString(3000));
	pMenu->AppendMenu(MF_ENABLED, iFirstCmd + 1, ThePlugIn().LocalizedString(3001));
/*
	// object menu in case there are selected once with keyframes etc.
	CBBTObjectWrapper wrap;
	if(wrap.SelectedObjectCount(true, true) > 0)
	{
		pMenu->AppendMenu(MF_SEPARATOR);

		m_pObjectSubMenu->DestroyMenu();
		m_pObjectSubMenu->CreatePopupMenu();

		m_pObjectSubMenu->AppendMenu(MF_ENABLED, iFirstCmd + 2, ThePlugIn().LocalizedString(3002));
		m_pObjectSubMenu->AppendMenu(MF_ENABLED, iFirstCmd + 3, ThePlugIn().LocalizedString(3003));
		m_pObjectSubMenu->AppendMenu(MF_ENABLED, iFirstCmd + 4, ThePlugIn().LocalizedString(3004));

		pMenu->AppendMenu(MF_STRING|MF_POPUP|MF_BYPOSITION,(UINT)(m_pObjectSubMenu->GetSafeHmenu()),
			ThePlugIn().LocalizedString(3008));
	}
	
	// view menu in case the active view is animated and has keyframes etc.
	CRhinoViewport* pViewport = &(RhinoApp().ActiveView()->Viewport());
	if(pViewport)
	{
		CBongoView* pBongoView = 0;
		if(CBongoView::ViewObject(pBongoView, pViewport) && pBongoView)
		{
			if(pBongoView->FirstKeyframe())
			{
				pMenu->AppendMenu(MF_SEPARATOR);

				m_pViewSubMenu->DestroyMenu();
				m_pViewSubMenu->CreatePopupMenu();

				m_pViewSubMenu->AppendMenu(MF_ENABLED, iFirstCmd + 5, ThePlugIn().LocalizedString(3005));
				m_pViewSubMenu->AppendMenu(MF_ENABLED, iFirstCmd + 6, ThePlugIn().LocalizedString(3006));
				m_pViewSubMenu->AppendMenu(MF_ENABLED, iFirstCmd + 7, ThePlugIn().LocalizedString(3007));

				pMenu->AppendMenu(MF_STRING|MF_POPUP|MF_BYPOSITION,(UINT)(m_pViewSubMenu->GetSafeHmenu()),
					ThePlugIn().LocalizedString(3009));
			}
		}

		delete pBongoView;
		pBongoView = 0;

	}
*/	

	return true;
}

bool CBBTTimelineExtension::OnContextMenuItemInvoked(const int iCmd, const int iCmdFirst,
													 const double dPos)
{
	bool bRet = false;

	CString sCommand;

	switch(iCmd-iCmdFirst)
	{
	case 0:
		sCommand = "_BongoBonusInsertTimelineTicks";
		break;
	case 1:
		sCommand = "_BongoBonusDeleteTimelineTicks";
		break;
	case 2:
		sCommand = "_BongoBonusMoveObjectKeyframeRange";
		break;
	case 3:
		sCommand = "_BongoBonusScaleObjectKeyframes";
		break;
	case 4:
		sCommand = "_BongoBonusDeleteObjectKeyframeRange";
		break;
	case 5:
		sCommand = "_BongoBonusMoveViewKeyframeRange";
		break;
	case 6:
		sCommand = "_BongoBonusScaleViewKeyframes";
		break;
	case 7:
		sCommand = "_BongoBonusDeleteViewKeyframeRange";
		break;	
	}

	if(!sCommand.IsEmpty())
	{
		 ON_wString wCommand(sCommand);

		if(dPos >= 0.0)
		{
			wCommand.Format("%s %d",sCommand,(int)dPos);
		}
	
		RhinoApp().RunScript(wCommand,0);
	}
		
	return bRet;
}