// BBTViewWrapper.cpp: implementation of the CBBTViewWrapper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BBTApp.h"
#include "BBTViewWrapper.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBBTViewWrapper::CBBTViewWrapper()
{

}

CBBTViewWrapper::~CBBTViewWrapper()
{

}

int CBBTViewWrapper::KeyframeCount(CBongoView* pView)
{
	if(!pView || !pView->IsValid() || !pView->IsAnimated())
		return 0;

	CBongoKeyframePtr KfPtr;
	int iCount = 0;
	
	for(KfPtr = pView->FirstKeyframe(); KfPtr; KfPtr = pView->NextKeyframe())
	{
		iCount++;
	}

	return iCount;
}

bool CBBTViewWrapper::DeleteAllKeyframes(CBongoView* pView)
{
	if(!pView)
		return false;

	CArray<double, double> aKFPos;
	CBongoKeyframePtr BongoPtrKf;	
	CBongoViewKeyframe* pBongoKf;
	
	for(BongoPtrKf = pView->FirstKeyframe(); BongoPtrKf;
		BongoPtrKf = pView->NextKeyframe())
	{
		pBongoKf = (CBongoViewKeyframe*)BongoPtrKf.Pointee();
		if(pBongoKf)
		{	
			aKFPos.Add(pBongoKf->Position());	
		}
	}

	for(int i=aKFPos.GetSize()-1; i>=0; i--)
	{
		pView->DeleteKeyframe(aKFPos[i],false);	
	}

	aKFPos.RemoveAll();

	return true;
}

CRhinoViewport* CBBTViewWrapper::ViewportLookup(ON_wString wViewName)
{
	if(wViewName.IsEmpty())
		return 0;

	CRhinoDoc* Doc = RhinoApp().ActiveDoc();
	ON_SimpleArray <CRhinoView*> aRhinoView;
	Doc->GetViewList(aRhinoView);
	
	for(int i=0; i<aRhinoView.Count(); i++)
	{
		if( wViewName.CompareNoCase( aRhinoView[i]->Viewport().Name() ) != 0 )
			continue;

		return &(aRhinoView[i]->Viewport());
	}

	return 0;
}